#pragma once
#include "B4RDefines.h"
#include "Dusk2Dawn.h"

//~Version: 1.01
//~Author: JDK
namespace B4R {
	//~Shortname: Dusk2Dawn
	class B4RDusk2Dawn {
		private:
			uint8_t backend[sizeof(Dusk2Dawn)];

		public:
			//~hide
			Dusk2Dawn* d2d;

			//Multiple instances can be created.
			void Initialize(float Latitude, float Longitude, float Timezone);

			// Returns Minutes elapsed since midnight
			int Sunrise(int Year, int Month, int Day, bool DayLightSavingTime);

			// Returns Minutes elapsed since midnight
			int Sunset(int Year, int Month, int Day, bool DayLightSavingTime);

			int GetHour(int MinutesSinceMidnight);

			int GetMinute(int MinutesSinceMidnight);
			
			int GetSunriseHour(int Year, int Month, int Day, bool DayLightSavingTime);

			int GetSunriseMinute(int Year, int Month, int Day, bool DayLightSavingTime);
			
			int GetSunsetHour(int Year, int Month, int Day, bool DayLightSavingTime);

			int GetSunsetMinute(int Year, int Month, int Day, bool DayLightSavingTime);
			
			bool IsDaylightSavingTime(int DayOfWeek, int Month, int Day);
			
	};
}
